package com.zskk.service;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.security.AlgorithmParameters;
import java.security.Key;
import java.util.Arrays;
import java.util.Date;
import java.util.Map;
import java.util.UUID;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import com.alibaba.fastjson.JSON;
import com.jfinal.kit.Base64Kit;
import com.jfinal.kit.HashKit;
import com.jfinal.weixin.sdk.api.ApiResult;
import com.jfinal.weixin.sdk.utils.Charsets;

import okhttp3.FormBody;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class UserService {

	private static final MediaType JSON_CODE = MediaType.get("application/json; charset=utf-8");

	private static final OkHttpClient OKHTTP_CLIENT = new OkHttpClient();

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public static String decrypt(String encryptedData, String ivStr) {
        byte[] bizData = Base64Kit.decode("zY5mNzlVRTEhY2V5bAgjtjCKBKIPhlHu1ct/ThHNgbIL/ZyxZ+amvQ7JSFSRh2b1JC+VisPN9MP/yBfdFbcvhuLLM0kXQLKOqd4zRWi5+SXTdnHHYdoIp+z2zE4mk277iBrg+LRyaJEwdZ7OvgNBedrkn6mDANwQNb2kn1slkP13Z3MMtiUJlEn2GSKboHv+VOdnNAp3AfIpxGhc+ZIH4w==");
        byte[] keyByte = Base64Kit.decode("9s89B/Ju7f9tSqifyPUboA==");
        byte[] ivByte  = Base64Kit.decode("tg1xdcVOnjSwfott9Dz58A==");
        try {
            Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
            Key sKeySpec = new SecretKeySpec(keyByte, "AES");
            // 初始化
            AlgorithmParameters params = AlgorithmParameters.getInstance("AES");
            params.init(new IvParameterSpec(ivByte));
            cipher.init(Cipher.DECRYPT_MODE, sKeySpec, params);
            byte[] original = cipher.doFinal(bizData);
            // 去除补位字符
            byte[] result = decode(original);
            return new String(result, Charsets.UTF_8);
        } catch (Exception e) {
            throw new RuntimeException("aes解密失败");
        }
    }
	
	static byte[] decode(byte[] decrypted) {
        int pad = (int) decrypted[decrypted.length - 1];
        if (pad < 1 || pad > 32) {
            pad = 0;
        }
        return Arrays.copyOfRange(decrypted, 0, decrypted.length - pad);
    }

	public static void main(String[] args) throws IOException {
		String aaaString=  decrypt("","");
		ApiResult apiResult = ApiResult.create(aaaString);
		System.out.println(apiResult);
	}
}
